/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef SAS_H
#define SAS_H

#include <U2Algorithm/MolecularSurface.h>

namespace U2
{

class SolventAccessibleSurface : public MolecularSurface
{
public:
    SolventAccessibleSurface();
    virtual qint64 estimateMemoryUsage(int numberOfAtoms);
    virtual void calculate(const QList<SharedAtom>& atoms, int& progress);
};

class SolventAccessibleSurfaceFactory : public MolecularSurfaceFactory
{
public:
    virtual MolecularSurface *createInstance()const;
};

} // namespace

#endif // SAS_H
